<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\works;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\property\PropertyOrder;
use app\common\model\works\ReturnWork;
use app\common\lists\ListsSearchInterface;
use think\db\Query;
use think\facade\Db;


/**
 * ReturnWork列表
 * Class ReturnWorkLists
 * @package app\adminapi\listsworks
 */
class ReturnWorkLists extends BaseAdminDataLists implements ListsSearchInterface
{

    public $queryExists = null;
    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function setSearch(): array
    {
        return [
            '=' => ['work_sn', 'service_work_id', 'issue_work_id', 'return_work_status', 'dispatch_time', 'appointment_time', 'finished_time', 'master_worker_id', 'create_time', 'update_time'],

        ];
    }

    /**
     * 获取数据权限
     * $this->adminInfo['data_rules']
     * province city admin_id sale_group_id sale_id  property_head_id
     */
    public function queryDataWhere(){
        $where = [];
        $data_rules = $this->adminInfo['data_rules'];
        $this->queryExists = function (Query $query) { $query->name('service_work')->where('id','>', 0)->field('id'); };
        if (isset($data_rules['province']) && !empty($data_rules['province'])) {
            $this->queryExists = function (Query $query) use ($data_rules)  {
                $p_table = $query->getTable().$query->getName();
                $query->name('service_work')->alias('b')
                    ->where('province','in', $data_rules['province'])
                    ->where($p_table.'.service_work_id', '=', Db::raw('b.id'))
                    ->field('id');
            };
        }
        if (isset($data_rules['city']) && !empty($data_rules['city'])) {
            $this->queryExists = function (Query $query) use ($data_rules) {
                $p_table = $query->getTable().$query->getName();
                $query->name('service_work')->alias('b')
                    ->where('city','in', $data_rules['city'])
                    ->where($p_table.'.service_work_id', '=', Db::raw('b.id'))
                    ->field('id');
            };
        }
        if (isset($data_rules['sale_group_id']) && !empty($data_rules['sale_group_id'])) {
            $work_ids = PropertyOrder::where('sale_group_id','in',$data_rules['sale_group_id'])->column('work_id')??[];
            $where[] = ['service_work_id','in' ,$work_ids];
        }
        if (isset($data_rules['sale_id']) && !empty($data_rules['sale_id'])) {
            $work_ids = PropertyOrder::where('sale_id','in',$data_rules['sale_id'])->column('work_id')??[];
            $where[] = ['service_work_id','in' ,$work_ids];
        }
        if (isset($data_rules['property_head_id']) && !empty($data_rules['property_head_id'])) {
            $work_ids = PropertyOrder::where('property_head_id','in',$data_rules['property_head_id'])->column('work_id')??[];
            $where[] = ['service_work_id','in' ,$work_ids];
        }
        return $where;
    }
    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function lists(): array
    {
        return ReturnWork::with(['masterWorker'=>function(Query $query){
            $query->field('id,real_name,worker_number');
        }])->where($this->searchWhere)
            ->where($this->queryDataWhere())
            ->whereExists($this->queryExists)
            ->field(['id', 'work_sn', 'service_work_id', 'issue_work_id', 'return_work_status', 'dispatch_time', 'appointment_time', 'finished_images', 'finished_time', 'master_worker_id', 'create_time', 'update_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function count(): int
    {
        return ReturnWork::where($this->searchWhere)->where($this->queryDataWhere())->whereExists($this->queryExists)->count();
    }

}